/* --------------------------------------------------------
   ̓_vZ

                                     2004/5/10
                                         S.Mio
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/* -------------------------------------------------------- */
#define true            (1)
#define false           (0)

#define TEHAI_LIMIT     (14)


/* -------------------------------------------------------- */
/*  */

#define YAKU_LIMIT (49)
#define FU_LIMIT (6)
#define HAN_LIMIT (4)

int score_oya_ron[HAN_LIMIT][FU_LIMIT] = {
    {1000,  1500,  2000,  2400,  2900,  3400,},
    {2000,  2900,  3900,  4800,  5800,  6800,},
    {3900,  5800,  7700,  9600, 11600, 12000,},
    {7700, 11600, 12000, 12000, 12000, 12000,},
};
int score_oya_tsumo[HAN_LIMIT][FU_LIMIT] = {
    {400,    500,   700,   800,  1000,  1200,},
    {700,   1000,  1300,  1600,  2000,  2300,},
    {1300,  2000,  2600,  3200,  3900,  4000,},
    {2600,  3900,  4000,  4000,  4000,  4000,},
};
int score_ko_ron[HAN_LIMIT][FU_LIMIT] = {
    { 700,  1000,  1300,  1600,  2000,  2300,},
    {1300,  2000,  2600,  3200,  3900,  4500,},
    {2600,  3900,  5200,  6400,  7700,  8000,},
    {5200,  7700,  4000,  4000,  4000,  4000,},
};
int score_ko_tsumo_ko[HAN_LIMIT][FU_LIMIT] = {
    { 200,   300,   400,   400,   500,   600,},
    { 400,   500,   700,   800,  1000,  1200,},
    { 700,  1000,  1300,  1600,  2000,  2000,},
    {1300,  2000,  2000,  2000,  2000,  2000,},
};
int score_ko_tsumo_oya[HAN_LIMIT][FU_LIMIT] = {
    { 400,   500,   700,   800,  1000,  1200,},
    { 700,  1000,  1300,  1600,  2000,  2300,},
    {1300,  2000,  2600,  3200,  3900,  4000,},
    {2600,  3900,  4000,  4000,  4000,  4000,},
};

/* 5|̓_ */
int score_mangan_oya_ron[] = {
     12000,  18000,  18000,  24000,
     24000,  24000,  36000,  36000,
     48000,
};
int score_mangan_oya_tsumo[] = {
     12000/3,  18000/3,  18000/3,  24000/3,
     24000/3,  24000/3,  36000/3,  36000/3,
     48000/3,
};
int score_mangan_ko_ron[] = {
     8000,  12000,  12000,  16000,
     16000, 16000,  24000,  24000,
     36000,
};
int score_mangan_ko_tsumo_oya[] = {
     4000,  6000,  6000,   8000,
     8000,  8000,  12000,  12000,
     16000,
};
int score_mangan_ko_tsumo_ko[] = {
     2000,  3000,  3000,  4000,
     4000,  4000,  6000,  6000,
     8000,
};

typedef struct {
    char *name;
    int han;
} t_yaku;

t_yaku yakutable[] = {
    {"c",        1,},
    {"[`",      1,},
    {"ꔭ",        1,},
    {"st",      1,},
    {"^I",    1,},
    {"u",      1,},
    {"",          1,},
    {"",          1,},
    {"",          1,},
    {"k",          1,},
    {"",          1,},
    {"",          1,},
    {"",          1,},
    {"nCeC",    1,},
    {"J",    1,},
    {"",        1,},
    {"h",        1,},
    {"_u[",    2,},
    {"_u",      2,},
    {"_u",      2,},
    {"Ύq",      2,},
    {"`^",    2,},
    {"Cʊ",    2,},
    {"OF",    2,},
    {"OF",    2,},
    {"gCgC",    2,},
    {"OÎq",      2,},
    {"OȎq",      2,},
    {"u",      3,},
    {"F",      3,},
    {"`",    3,},
    {"O",      4,},
    {"V",      4,},
    {"la",        4,},
    {"F",      6,},
    {"lÍ",      13,},
    {"PR",        13,},
    {"lȎq",      13,},
    {"O",      13,},
    {"mo",    13,},
    {"Va",        13,},
    {"na",        13,},
    {"la",    13,},
    {"la",    13,},
    {"F",      13,},
    {"V",      13,},
    {"ΈF",      13,},
    {"A",    13,},
    {"\Os",    13,},
};

#define YAKU_TSUMO          (0)
#define YAKU_RIICHI         (1)
#define YAKU_IIPATSU        (2)
#define YAKU_PINFU          (3)
#define YAKU_TANYAO         (4)
#define YAKU_IIPEIKOU       (5)
#define YAKU_TON            (6)
#define YAKU_NAN            (7)
#define YAKU_SYA            (8)
#define YAKU_PEI            (9)
#define YAKU_HAKU           (10)
#define YAKU_HATSU          (11)
#define YAKU_CYUN           (12)
#define YAKU_HAITEI         (13)
#define YAKU_RINSYAN        (14)
#define YAKU_CYANKAN        (15)
#define YAKU_DORA           (16)
#define YAKU_DABURII        (17)
#define YAKU_DABUTON        (18)
#define YAKU_DABUNAN        (19)
#define YAKU_TIITOITSU      (20)
#define YAKU_TYANTA         (21)
#define YAKU_IITSU          (22)
#define YAKU_SANSYOKU       (23)
#define YAKU_SANSYOKUDOKOKU (24)
#define YAKU_TOITOI         (25)
#define YAKU_SANANKO        (26)
#define YAKU_SANKANTSU      (27)
#define YAKU_RYANPEIKOU     (28)
#define YAKU_HONITSU        (29)
#define YAKU_JUNCHAN        (30)
#define YAKU_SYOSANGEN      (31)
#define YAKU_HONROUTOU      (32)
#define YAKU_RENHOU         (33)
#define YAKU_TINITSU        (34)
#define YAKU_SUANKO         (35)
#define YAKU_SUANKO_TANKI   (36)
#define YAKU_SUKANTSU       (37)
#define YAKU_DAISANGEN      (38)
#define YAKU_KOKUSHI        (39)
#define YAKU_TENHOU         (40)
#define YAKU_TIIHOU         (41)
#define YAKU_DAISUSHI       (42)
#define YAKU_SYOSUSHI       (43)
#define YAKU_TSUUIISOU      (44)
#define YAKU_TINROUTOU      (45)
#define YAKU_RYUIISOU       (46)
#define YAKU_TSURENPOUTON   (47)
#define YAKU_SIISANPUUTAO   (48)


/* -------------------------------------------------------- */
#define PAI_MANZU           (0)
#define PAI_SOUZU           (1)
#define PAI_PINZU           (2)
#define PAI_ZIHAI           (3)
#define PAI_CATEGORYLIMIT   (4)

#define PAI_TON         (0)
#define PAI_NAN         (1)
#define PAI_SYA         (2)
#define PAI_PEI         (3)
#define PAI_HAKU        (4)
#define PAI_HATSU       (5)
#define PAI_TYUN        (6)

#define PAINO_1_9       (7)
#define PAINO_2_8       (8)
#define PAINO_LIMIT     (9)

#define UKIHAI          (0)
#define KOUTSU          (1)
#define SYUNTSU_START   (2)
#define SYUNTSU_MIDDLE  (3)
#define SYUNTSU_END     (4)
#define KANTSU          (5)
#define ATAMA           (6)
#define TOITSU          (7)
#define MENTSU_LIMIT    (8)

#define MATI_RYANMEN    (0)
#define MATI_PENCHAN    (1)
#define MATI_KANCHAN    (2)
#define MATI_SYABO      (3)
#define MATI_TANKI      (4)

#define NOMANGAN        (0)
#define MANGAN          (1)
#define HANEMAN         (2)
#define BAIMAN          (3)
#define SANBAIMAN       (4)
#define YAKUMAN         (5)
#define DOUBLEYAKUMAN   (6)
#define TRIPURUYAKUMAN  (7)

#define RESLUTITEM_LIMIT    (32)
#define DORAPAI_LIMIT       (8)


/* vf[^ */
typedef struct {
  int category;
  int no;
} t_pai;

/* hv */
typedef struct {
  t_pai *pai[DORAPAI_LIMIT];
} t_dorapai;

/* Ƃ̏ */
typedef struct {
  int bakaze;       /* ꕗ             */
  int zikaze;       /*              */
  int count;        /* ŏ             */
  int riichicount;  /* [`̑ŏ   */
  int endpai;       /* I̔v       */
  int kan;          /* OɃJ       */
  int tsumo;        /* OɃc       */
  int riichi;       /* [`Ă   */
  int oya;          /* eǂ       */
  int agarihai;     /* オv       */
  int naki;         /* Ȃǂ   */
  int membernaki;   /* ̐lȂ */
  t_dorapai *dora;  /* hv           */
} t_gamestate;

/* Wv */
typedef struct {
  t_pai *pai;
  int count;
  int startpos;
} t_paicountitem;

/* Ug̐ */
typedef struct {
  int mentsu_tehai[TEHAI_LIMIT];    /* vƂ̖ʎq     */
  int mentsu_count[MENTSU_LIMIT];   /* ʎqƂ̃JEg */
  int yaku[YAKU_LIMIT];             /*                  */
  int fu;                           /*                  */
  int han;                          /*                  */
  int mangan;                       /* шȍ~           */
  int score;                        /* _(_)     */
  int oyascore;                     /* q̓_           */
  int koscore;                      /* e̓_           */
  int mati;                         /* ҂̎         */
  int dora;                         /* h̐           */
  int paicategorycountlist[PAI_CATEGORYLIMIT];
  int painocountlist[PAINO_LIMIT];
} t_resultitem;

t_resultitem resultlist[RESLUTITEM_LIMIT];
int resultcount;


/* -------------------------------------------------------- */
/*  */
t_pai q1array[] = {
    {PAI_MANZU, 2},
    {PAI_MANZU, 2},
    {PAI_MANZU, 3},
    {PAI_MANZU, 3},
    {PAI_MANZU, 3},
    {PAI_MANZU, 4},
    {PAI_MANZU, 4},
    {PAI_MANZU, 4},
    {PAI_MANZU, 5},
    {PAI_SOUZU, 2},
    {PAI_SOUZU, 3},
    {PAI_SOUZU, 4},
    {PAI_PINZU, 5},
    {PAI_PINZU, 5},
};

t_pai q2array[] = {
    {PAI_MANZU, 1},
    {PAI_MANZU, 1},
    {PAI_MANZU, 1},
    {PAI_SOUZU, 4},
    {PAI_SOUZU, 5},
    {PAI_SOUZU, 5},
    {PAI_SOUZU, 6},
    {PAI_SOUZU, 6},
    {PAI_SOUZU, 7},
    {PAI_SOUZU, 7},
    {PAI_SOUZU, 7},
    {PAI_ZIHAI, PAI_HATSU},
    {PAI_ZIHAI, PAI_HATSU},
    {PAI_ZIHAI, PAI_HATSU},
};

t_pai q3array[] = {
    {PAI_SOUZU, 1},
    {PAI_SOUZU, 2},
    {PAI_SOUZU, 3},
    {PAI_SOUZU, 9},
    {PAI_SOUZU, 9},
    {PAI_SOUZU, 9},
    {PAI_ZIHAI, PAI_HAKU},
    {PAI_ZIHAI, PAI_HAKU},
    {PAI_ZIHAI, PAI_HAKU},
    {PAI_ZIHAI, PAI_HATSU},
    {PAI_ZIHAI, PAI_HATSU},
    {PAI_ZIHAI, PAI_TYUN},
    {PAI_ZIHAI, PAI_TYUN},
    {PAI_ZIHAI, PAI_TYUN},
};

t_gamestate q1state = {
    PAI_TON,    /* ꕗ             */
    PAI_TON,    /*              */
    6,          /* ŏ             */
    0,          /* [`̑ŏ   */
    false,      /* I̔v       */
    false,      /* OɃJ       */
    true,       /* OɃc       */
    false,      /* [`Ă   */
    true,       /* eǂ       */
    9,          /* オv       */
    false,      /* Ȃǂ   */
    false,      /* ̐lȂ */
    NULL,       /* hv           */
};

t_gamestate q2state = {
    PAI_TON,    /* ꕗ             */
    PAI_TON,    /*              */
    6,          /* ŏ             */
    0,          /* [`̑ŏ   */
    false,      /* I̔v       */
    false,      /* OɃJ       */
    true,       /* OɃc       */
    false,      /* [`Ă   */
    true,       /* eǂ       */
    13,         /* オv       */
    false,      /* Ȃǂ   */
    false,      /* ̐lȂ */
    NULL,       /* hv           */
};

t_gamestate q3state = {
    PAI_TON,    /* ꕗ             */
    PAI_TON,    /*              */
    6,          /* ŏ             */
    0,          /* [`̑ŏ   */
    false,      /* I̔v       */
    false,      /* OɃJ       */
    true,       /* OɃc       */
    false,      /* [`Ă   */
    true,       /* eǂ       */
    10,         /* オv       */
    false,      /* Ȃǂ   */
    false,      /* ̐lȂ */
    NULL,       /* hv           */
};


/* -------------------------------------------------------- */
/* ̌`l镔 */

/* qǂ𒲂ׂ */
int iskoutsu(t_paicountitem *paicountlist)
{
    if (paicountlist->count >= 3)
        return true;
    return false;
}

/* qǂ𒲂ׂ(Ê) */
int issyuntsu(t_paicountitem *paicountlist)
{
    t_pai *pai, *nextpai;
    int i;

    for (i = 0; i < 2; i++) {
        pai = paicountlist->pai;
        if (pai == NULL)
            return false;
        nextpai = (paicountlist + 1)->pai;
        if (nextpai == NULL)
            return false;
        if ((pai->category == PAI_ZIHAI) ||
            (nextpai->category == PAI_ZIHAI))
            return false;
        if (pai->category != nextpai->category)
            return false;
        if ((paicountlist->count == 0) ||
            ((paicountlist + 1)->count == 0))
            return false;
        if (pai->no != nextpai->no - 1)
            return false;
        paicountlist++;
    }
    return true;
}

/* \Os/moǂׂ */
int search_siisan(t_paicountitem *paicountlist)
{
    t_pai *pai, *nextpai;
    
    while (paicountlist->pai != NULL) {
        pai     = paicountlist->pai;
        nextpai = (paicountlist + 1)->pai;
        if (nextpai == NULL)
            return true;
        if (paicountlist->count >= 2)
            return false;
        if ((pai->category != PAI_ZIHAI) &&
            (pai->category == nextpai->category) &&
            ((pai->no == nextpai->no - 1) ||
             (pai->no == nextpai->no - 2))) {
            return false;
        }
        paicountlist++;
    }
    return true;
}

/* make_resultitem̐ݒ蕔 */
t_resultitem *set_resultitem(t_pai *paiarray, int *mentsu, t_gamestate *gamestate)
{
    t_resultitem *item;
    int i, mentsono, pos;
    
    item = &resultlist[resultcount];
    resultcount++;
    memcpy(item->mentsu_tehai, mentsu, TEHAI_LIMIT * sizeof(int));
    
    for (i = 0; i < MENTSU_LIMIT; i++)
        item->mentsu_count[i] = 0;
    for (i = 0; i < YAKU_LIMIT; i++)
        item->yaku[i] = 0;

    for (i = 0; i < TEHAI_LIMIT; i++) {
        mentsono = item->mentsu_tehai[i];
        item->mentsu_count[mentsono]++;
    }
    item->fu = 0;
    item->score = 0;
    
    /* eWv */
    for (i = 0; i < PAINO_LIMIT; i++)
        item->painocountlist[i] = 0;
    for (i = 0; i < PAI_CATEGORYLIMIT; i++)
        item->paicategorycountlist[i] = 0;

    for (i = 0; i < TEHAI_LIMIT; i++) {
        item->paicategorycountlist[paiarray[i].category]++;
        if (paiarray[i].category == PAI_ZIHAI) {
            item->painocountlist[paiarray[i].no]++;
        } else {
            if ((paiarray[i].no == 1) || 
                (paiarray[i].no == 9)) {
                item->painocountlist[PAINO_1_9]++;
            } else {
                item->painocountlist[PAINO_2_8]++;
            }
        }
    }
    return item;
}

/* resultitemresultlist1Đݒ */
int make_resultitem(t_pai *paiarray, int *mentsu, t_gamestate *gamestate)
{
    t_resultitem *item;
    t_pai *agarihai;
    int mentsuflag[MENTSU_LIMIT];
    int i, pos, mati, mentsuno, result, entryitemflag;

    /* ҂̐ݒ */
    item = set_resultitem(paiarray, mentsu, gamestate);
    pos = gamestate->agarihai;
    agarihai = &paiarray[pos];

    for (i = 0; i < MENTSU_LIMIT; i++)
        mentsuflag[i] = false;
    for (i = 0; i < TEHAI_LIMIT; i++) {
        if ((paiarray[i].category == agarihai->category) &&
            (paiarray[i].no == agarihai->no)) {
            mentsuno = mentsu[i];
            mentsuflag[mentsuno] = true;
        }
    }

    entryitemflag = true;
    for (i = 0; i < MENTSU_LIMIT; i++) {
        if (!mentsuflag[i])
            continue;
        switch (i) {
          case KOUTSU:
            mati = MATI_SYABO;
            break;
          case ATAMA:
            mati = MATI_TANKI;
            break;
          case SYUNTSU_MIDDLE:
            mati = MATI_KANCHAN;
            break;
          case SYUNTSU_START:
            if (agarihai->no == 7) {
                mati = MATI_PENCHAN;
            } else {
                mati = MATI_RYANMEN;
            }
            break;
          case SYUNTSU_END:
            if (agarihai->no == 3) {
                mati = MATI_PENCHAN;
            } else {
                mati = MATI_RYANMEN;
            }
            break;
        }
        if (!entryitemflag) {
            item = set_resultitem(paiarray, mentsu, gamestate);
        }
        item->mati = mati;
        entryitemflag = false;
    }
    return resultcount;
}

/* TJnʎq̏Ԃݒ */
int setstartmentsu(t_pai *paiarray, int *mentsu, t_gamestate *gamestate, int atamapos)
{
    int i, j, paicountlistcount, pos, koutsuflag, syuntsuflag;
    t_paicountitem paicountlist[TEHAI_LIMIT + 1];

    /* ŏ̖ʎqɓݒ */
    for (i = 0; i < TEHAI_LIMIT; i++)
        mentsu[i] = UKIHAI;
    mentsu[atamapos] = ATAMA;
    mentsu[atamapos+1] = ATAMA;

    /* v̏Wv */
    paicountlistcount = 0;
    pos = 0;

    paicountlist[pos].pai = NULL;
    for (i = 0; i < TEHAI_LIMIT; i++) {
        /* ͏WvɓȂ */
        if ((i == atamapos) || (i == atamapos + 1))
            continue;
        if ((paicountlist[pos].pai != NULL) &&
            (paicountlist[pos].pai->category == paiarray[i].category) &&
            (paicountlist[pos].pai->no == paiarray[i].no)) {
            paicountlist[pos].count++;
        } else {
            paicountlistcount++;
            if (paicountlist[pos].pai != NULL)
                pos++;
            paicountlist[pos].pai = &paiarray[i];
            paicountlist[pos].count = 1;
            paicountlist[pos].startpos = i;
        }
    }
    paicountlist[pos + 1].pai = NULL;

    /* \Os/moׂ */
    if (search_siisan(paicountlist)) {
        /* Ȃݒ肵ďI */
        return make_resultitem(paiarray, mentsu, gamestate);
    }

    /* Tn߂邽߂Ɋm肵ĂƂ߂ */
    for (i = 0; i < paicountlistcount; i++) {
        
        koutsuflag  = iskoutsu(paicountlist + i);
        syuntsuflag = issyuntsu(paicountlist + i);
        
        /* ̈ʒuqŏqłȂΊm */
        if ((koutsuflag) && (!syuntsuflag)) {
            if ((i >= 1) && (issyuntsu(paicountlist + (i - 1))))
                continue;
            if ((i >= 2) && (issyuntsu(paicountlist + (i - 2))))
                continue;

            pos = paicountlist[i].startpos;
            mentsu[pos] = KOUTSU;
            mentsu[pos + 1] = KOUTSU;
            mentsu[pos + 2] = KOUTSU;
            continue;
        }

        /* ̈ʒuqł3̔vqłȂΊm */
        if ((!koutsuflag) && (syuntsuflag)) {
            if (i <= paicountlistcount - 3) {
                if (iskoutsu(paicountlist + i + 1))
                    continue;
                if (iskoutsu(paicountlist + i + 2))
                    continue;
    		    if ((paicountlist + i)->count >= 2)
                    continue;
                pos = paicountlist[i].startpos;
                mentsu[pos] = SYUNTSU_START;
                paicountlist[i].count--;
                paicountlist[i].startpos++;
                pos = paicountlist[i + 1].startpos;
                mentsu[pos] = SYUNTSU_MIDDLE;
                paicountlist[i + 1].count--;
                paicountlist[i + 1].startpos++;
                pos = paicountlist[i + 2].startpos;
                mentsu[pos] = SYUNTSU_END;
                paicountlist[i + 2].count--;
                paicountlist[i + 2].startpos++;
                continue;
            }
        }
    }
    return 0;
}

/* v̐𐔂 */
int setpaicount(t_paicountitem *paicountlist, t_pai *paiarray, int *mentsu)
{
    int pos, i;

    pos = 0;
    paicountlist[pos].pai = NULL;
    for (i = 0; i < TEHAI_LIMIT; i++) {
        /* vȊO͏WvɓȂ */
        if (mentsu[i] != UKIHAI)
            continue;
        if ((paicountlist[pos].pai != NULL) &&
            (paicountlist[pos].pai->category == paiarray[i].category) &&
            (paicountlist[pos].pai->no == paiarray[i].no)) {
            paicountlist[pos].count++;
        } else {
            if (paicountlist[pos].pai != NULL)
                pos++;
            paicountlist[pos].pai = &paiarray[i];
            paicountlist[pos].count = 1;
            paicountlist[pos].startpos = i;
        }
    }
    if (paicountlist[0].pai != NULL) {
        pos++;
        paicountlist[pos].pai = NULL;
    }
    return pos;
}

/* v邩Ԃ */
int isukihai(t_paicountitem *paicountlist)
{
    if (paicountlist[0].pai == NULL) {
        return false;
    }
    return true;
}

/* qZbg */
int setkoutsu(t_paicountitem *paicountlist, int *mentsu)
{
    t_pai *pai;
    int pos;
    
    if (iskoutsu(paicountlist)) {
        pos = paicountlist->startpos;
        mentsu[pos] = KOUTSU;
        mentsu[pos + 1] = KOUTSU;
        mentsu[pos + 2] = KOUTSU;
        return true;
    }
    return false;
}

/* qZbg */
int setsyuntsu(t_paicountitem *paicountlist, int *mentsu)
{
    int pos;
    
    if (issyuntsu(paicountlist)) {
        pos = paicountlist->startpos;
        mentsu[pos] = SYUNTSU_START;
        pos = (paicountlist + 1)->startpos;
        mentsu[pos] = SYUNTSU_MIDDLE;
        pos = (paicountlist + 2)->startpos;
        mentsu[pos] = SYUNTSU_END;
        return true;
    }
    return false;
}


/* ΎqZbgł邩ǂׂ */
int istoitsu(t_paicountitem *paicountlist, t_pai *atamapai)
{
    int pos, count;
    
    count = 0;
    while (paicountlist->pai != NULL) {
        if (paicountlist->count != 2)
            return false;
        if ((paicountlist->pai->category == atamapai->category) &&
            (paicountlist->pai->no == atamapai->no))
            return false;
        
        paicountlist++;
        count++;
    }
    if (count >= 6)
	    return true;
    return false;
}

/* ΎqZbg */
int settoitsu(t_paicountitem *paicountlist, int *mentsu)
{
    int pos;
    
    while (paicountlist->pai != NULL) {
        pos = paicountlist->startpos;
        mentsu[pos] = TOITSU;
        mentsu[pos + 1] = TOITSU;
        paicountlist++;
    }
    return true;
}

/* ̌`𓾂 */
int search_agari(t_pai *paiarray, t_gamestate *gamestate)
{
    t_paicountitem paicountlist[TEHAI_LIMIT + 1];
    int atamaque[TEHAI_LIMIT];
    int atamaque_count, atamapos;
    int mentsu_stack[256][TEHAI_LIMIT];
    int mentsu[TEHAI_LIMIT];
    int stackpos;
    int i, j, result, initresult, flag;

    /* ̌𓾂 */
    resultcount = 0;
    atamaque_count = 0;
    for (i = 0; i < TEHAI_LIMIT-1; i++) {
        if ((paiarray[i].category == paiarray[i+1].category) &&
            (paiarray[i].no == paiarray[i+1].no)) {
            atamaque[atamaque_count] = i;
            atamaque_count++;
            i++;
        }
    }
    
    if (atamaque_count == 0)
        return -1;

    /* ƂĎƂōq/qȂǂ̖ʎq̏󋵂 */
    result = -1;
    for (i = 0; i < atamaque_count; i++) {
        atamapos = atamaque[i];

        /* TJnʎq̏Ԃݒ */
        initresult = setstartmentsu(paiarray, mentsu_stack[0], gamestate, atamapos);
        if (initresult != 0)
            return initresult;
        
        /* Ύq𒲂ׂ */
        setpaicount(paicountlist, paiarray, mentsu_stack[0]);
        if (istoitsu(paicountlist, &paiarray[atamapos])) {
            memcpy(mentsu, mentsu_stack[0], TEHAI_LIMIT * sizeof(int));
            settoitsu(paicountlist, mentsu);
            result = make_resultitem(paiarray, mentsu, gamestate);
        }

        /* T */
        stackpos = 0;
        do {
            setpaicount(paicountlist, paiarray, mentsu_stack[stackpos]);
            if (isukihai(paicountlist)) {  /* v܂ */
                memcpy(mentsu, mentsu_stack[stackpos], TEHAI_LIMIT * sizeof(int));
                flag = setkoutsu(paicountlist, mentsu_stack[stackpos]);
                if (flag) {
                    stackpos++;

                    /* ɔđҔĂeRs[ */
                    memcpy(mentsu_stack[stackpos], mentsu, TEHAI_LIMIT * sizeof(int));
                }
                flag = setsyuntsu(paicountlist, mentsu_stack[stackpos]);
                if (flag) {
                    stackpos++;
                }
            } else {
                result = make_resultitem(paiarray, mentsu_stack[stackpos], gamestate);
            }
            stackpos--;
        } while(stackpos >= 0);
    }
    return result;
}


/* -------------------------------------------------------- */
/* ꂼ̖𔻒f镔 */

typedef int (*t_yakufunc)(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);

/* vg^Cv */
int isTsumo(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isRiichi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isIppatsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isPinfu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTanyao(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isIipeikou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTon(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isNan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSya(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isPeki(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isHaku(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isHatsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isCyun(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isHaitei(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isRinsyan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isCyankan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isDora(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isDaburii(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isDabuTon(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isDabuNan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTiitoitsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTyanta(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int Ittsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSansyoku(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSanren(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isToitoi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSananko(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSankantsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isRyanpeikou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isHonitsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isJunchan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSyousangen(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isHonroutou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isRenhou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTinitsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSuuanko(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSuuankoTanki(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSuukantsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isDaisangen(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isKokushi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTenhou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTiihou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isDaisushi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSyousushi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTsuuiisou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTinroutou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isRiuiisou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isTyuren(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);
int isSiisanPuutao(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item);


/* 1ʖ */
/* c */
int isTsumo(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (gamestate->tsumo)
        return true;
    return false;
}

/* [` */
int isRiichi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (isDaburii(paiarray, gamestate, item))
        return false;
    if (gamestate->riichi)
        return true;
    return false;
}

/* ꔭ */
int isIppatsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((gamestate->riichi) && (gamestate->riichicount == 1))
        return true;
    return false;
}

/* st */
int isPinfu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    t_pai *atamapai;
    int i, count;
    
    if (gamestate->naki)
        return false;
    if (item->mati != MATI_RYANMEN)
        return false;
    if (item->mentsu_count[SYUNTSU_START] != 4)
        return false;
    if (item->paicategorycountlist[PAI_ZIHAI]) {
        if ((item->painocountlist[PAI_HAKU]) ||
            (item->painocountlist[PAI_HATSU]) ||
            (item->painocountlist[PAI_TYUN]))
            return false;
        
        count = 0;
        for (i = PAI_TON; i <= PAI_PEI; i++) {
            if (item->painocountlist[i] == 0)
                continue;
            if (item->painocountlist[i] != 2)
                return false;
            if ((i == gamestate->bakaze) || (i == gamestate->zikaze))
                return false;
            count += item->painocountlist[i];
        }
        if (count != 2)
            return false;
    }
    return true;
}

/* ^I */
int isTanyao(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i;
    
    if (item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAINO_1_9])
        return false;
    return true;
}

/* u */
int isIipeikou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i;
    
    if (item->mentsu_count[SYUNTSU_START] < 2)
        return false;
    if (isRyanpeikou(paiarray, gamestate, item))
        return false;
    for (i = 0; i < TEHAI_LIMIT - 1; i++) {
        if (item->mentsu_tehai[i] == SYUNTSU_START) {
            if (item->mentsu_tehai[i + 1] != SYUNTSU_START)
                continue;
            return true;
        }
    }
    return false;
}

/*  */
int isTon(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAI_TON] < 3)
        return false;
    if (isDabuTon(paiarray, gamestate, item))
        return false;
    if ((gamestate->bakaze == PAI_TON) ||
        (gamestate->zikaze == PAI_TON))
        return true;
    return false;
}

/*  */
int isNan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAI_NAN] < 3)
        return false;
    if (isDabuNan(paiarray, gamestate, item))
        return false;
    if ((gamestate->bakaze == PAI_NAN) ||
        (gamestate->zikaze == PAI_NAN))
        return true;
    return false;
}

/*  */
int isSya(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAI_SYA] < 3)
        return false;
    if (gamestate->zikaze == PAI_SYA)
        return true;
    return false;
}

/* k */
int isPeki(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAI_PEI] < 3)
        return false;
    if (gamestate->zikaze == PAI_PEI)
        return true;
    return false;
}

/*  */
int isHaku(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAI_HAKU] < 3)
        return false;
    if (isSyousangen(paiarray, gamestate, item))
        return false;
    return true;
}

/*  */
int isHatsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAI_HATSU] < 3)
        return false;
    if (isSyousangen(paiarray, gamestate, item))
        return false;
    return true;
}

/*  */
int isCyun(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAI_TYUN] < 3)
        return false;
    if (isSyousangen(paiarray, gamestate, item))
        return false;
    return true;
}

/* nCeC */
int isHaitei(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (gamestate->endpai)
        return true;
    return false;
}

/* J */
int isRinsyan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((gamestate->kan) && (gamestate->tsumo))
        return true;
    return false;
}

/*      */
int isCyankan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((gamestate->kan) && (!gamestate->tsumo))
        return true;
    return false;
}

/* h     */
int isDora(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    t_dorapai *dorapai;
    int i, dorapos;
    
    if (gamestate->dora != NULL) {
        item->dora = 0;
        dorapai = gamestate->dora;
        
        for (i = 0; i < TEHAI_LIMIT; i++) {
            for (dorapos = 0; dorapos < DORAPAI_LIMIT; dorapos++) {
                if (dorapai->pai[dorapos] == NULL)
                    continue;
            
                if ((paiarray[i].category == dorapai->pai[dorapos]->category) &&
                    (paiarray[i].no == dorapai->pai[dorapos]->no)) {
                    item->dora++;
                    break;
                }
            }
        }
    }
    return false; 
}

/* 2ʖ */
/* _u[ */
int isDaburii(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((gamestate->riichi) && 
        (gamestate->riichicount == gamestate->count))
        return true;
    return false;
}

/* _u */
int isDabuTon(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAI_TON] < 3)
        return false;
    if ((gamestate->bakaze == PAI_TON) &&
        (gamestate->zikaze == PAI_TON))
        return true;
    return false;
}

/* _u */
int isDabuNan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAI_NAN] < 3)
        return false;
    if ((gamestate->bakaze == PAI_NAN) &&
        (gamestate->zikaze == PAI_NAN))
        return true;
    return false;
}

/* Ύq */
int isTiitoitsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (isHonroutou(paiarray, gamestate, item))
        return false;
    if (item->mentsu_count[TOITSU] == 6*2)
        return true;
    return false;
}

/* `^ */
int isTyanta(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i;

    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (!item->mentsu_count[SYUNTSU_START])
        return false;

    for (i = 0; i < TEHAI_LIMIT; i++) {
        if ((item->mentsu_tehai[i] == SYUNTSU_MIDDLE) ||
            (item->mentsu_tehai[i] == SYUNTSU_END))
            continue;
        if (item->mentsu_tehai[i] == SYUNTSU_START) {
            if ((paiarray[i].no != 1) &&
                (paiarray[i].no != 7)) {
                return false;
            }
        } else if (paiarray[i].category != PAI_ZIHAI) {
            if ((paiarray[i].no != 1) &&
                (paiarray[i].no != 9)) {
                return false;
            }
        }
    }
    return true;
}

/* Cʊ */
int Ittsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int flagtable[3];
    int category, i, j;

    if (item->mentsu_count[SYUNTSU_START] < 3)
        return false;
    category = -1;
    for (j = 0; j < 3; j++)
        flagtable[j] = 0;
    for (i = 0; i < TEHAI_LIMIT; i++) {
        if (paiarray[i].category == PAI_ZIHAI)
            continue;
        if (paiarray[i].category != category) {
		    if ((flagtable[0] >= 1) &&
	    	    (flagtable[1] >= 1) &&
		        (flagtable[2] >= 1))
			        return true;
            category = paiarray[i].category;
            for (j = 0; j < 3; j++)
                flagtable[j] = 0;
        }
        if (item->mentsu_tehai[i] == SYUNTSU_START) {
            if (paiarray[i].no == 1)
                flagtable[0]++;
            if (paiarray[i].no == 4)
                flagtable[1]++;
            if (paiarray[i].no == 7)
                flagtable[2]++;
        }
    }
    
    if ((flagtable[0] >= 1) &&
        (flagtable[1] >= 1) &&
        (flagtable[2] >= 1))
        return true;

    return false;
}

/* OF */
int isSansyoku(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int notable[3][9];    /* SYUNTSU_START̂Ƃ̐ */
    int i, no, category;
    
    if ((!item->paicategorycountlist[PAI_MANZU]) ||
        (!item->paicategorycountlist[PAI_SOUZU]) ||
        (!item->paicategorycountlist[PAI_PINZU]))
        return false;
    if (item->mentsu_count[SYUNTSU_START] < 3)
        return false;
    
    for (category = PAI_MANZU; category <= PAI_PINZU; category++) {
        for (i = 0; i < 9; i++) {
            notable[category][i] = 0;
        }
    }
    
    for (i = 0; i < TEHAI_LIMIT; i++) {
        if (item->mentsu_tehai[i] == SYUNTSU_START) {
            no = paiarray[i].no;
            category = paiarray[i].category;
            if (category == PAI_ZIHAI)
                continue;
            notable[category][no]++;
        }
    }
    for (i = 0; i < 9; i++) {
        if ((notable[PAI_MANZU][i]) &&
            (notable[PAI_SOUZU][i]) &&
            (notable[PAI_PINZU][i]))
            return true;
    }
    return false;
}

/* OF */
int isSanren(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int notable[3][9];    /* KOUTSU/ANKAN̂Ƃ̐ */
    int i, no, category;
    
    if ((!item->paicategorycountlist[PAI_MANZU]) ||
        (!item->paicategorycountlist[PAI_SOUZU]) ||
        (!item->paicategorycountlist[PAI_PINZU]))
        return false;
    if ((item->mentsu_count[KOUTSU] + 
         item->mentsu_count[KANTSU]) < 3)
        return false;
    
    for (category = PAI_MANZU; category <= PAI_PINZU; category++) {
        for (i = 0; i < 9; i++) {
            notable[category][i] = 0;
        }
    }
    
    for (i = 0; i < TEHAI_LIMIT; i++) {
        if ((item->mentsu_tehai[i] == KOUTSU) ||
            (item->mentsu_tehai[i] == KANTSU)) {
            no = paiarray[i].no;
            category = paiarray[i].category;
            if (category == PAI_ZIHAI)
                continue;
            notable[category][no]++;
            if (item->mentsu_tehai[i] == KOUTSU)
                i += 2;
            else
                i += 3;
        }
    }
    for (i = 0; i < 9; i++) {
        if ((notable[PAI_MANZU][i]) &&
            (notable[PAI_SOUZU][i]) &&
            (notable[PAI_PINZU][i])) {
            return true;
        }
    }
    return false;
}

/* gCgC */
int isToitoi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int count;
    
    count = item->mentsu_count[KOUTSU]/3;
    count += item->mentsu_count[KANTSU]/4;
    if (count < 4)
        return false;
    if (isHonroutou(paiarray, gamestate, item))
        return false;
    return true;
}

/* OÎq   */
int isSananko(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int count;
    
    count = item->mentsu_count[KOUTSU]/3;
    if (count == 3)
        return true;
    return false;
}

/* OȎq   */
int isSankantsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int count;
    
    count = item->mentsu_count[KANTSU]/4;
    if (count == 3)
        return true;
    return false;
}

/* 3ʖ */
/* u */
int isRyanpeikou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i, count;

    if (item->mentsu_count[SYUNTSU_START] < 4)
        return false;
    count = 0;
    for (i = 0; i < TEHAI_LIMIT; i++) {
        if (item->mentsu_tehai[i] == SYUNTSU_START) {
            if (item->mentsu_tehai[i + 1] != SYUNTSU_START)
                return false;
            count++;
            i++;
        }
    }
    if (count == 2)
        return true;
    return false;
}

/* F */
int isHonitsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i, count;

    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    
    count = 0;
    for (i = PAI_MANZU; i <= PAI_PINZU; i++) {
        if (item->paicategorycountlist[i])
            count++;
    }
    if (count != 1)
        return false;
    return true;
}

/* ` */
int isJunchan(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i;

    if (item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (!item->mentsu_count[SYUNTSU_START])
        return false;

    for (i = 0; i < TEHAI_LIMIT; i++) {
        if ((item->mentsu_tehai[i] == SYUNTSU_MIDDLE) ||
            (item->mentsu_tehai[i] == SYUNTSU_END))
            continue;
        if (item->mentsu_tehai[i] == SYUNTSU_START) {
            if ((paiarray[i].no != 1) &&
                (paiarray[i].no != 7)) {
                return false;
            }
        } else  {
            if ((paiarray[i].no != 1) &&
                (paiarray[i].no != 9)) {
                return false;
            }
        }
    }
    return true;
}

/* 4ʖ */
/* O */
int isSyousangen(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
	int i, flag;

    if ((item->painocountlist[PAI_HAKU] < 2) ||
        (item->painocountlist[PAI_HATSU] < 2) ||
        (item->painocountlist[PAI_TYUN] < 2))
        return false;
    
    flag = false;
    for (i = 0; i < 3; i++) {
        if (item->painocountlist[PAI_HAKU + i] == 2) {
            if (flag) {
                return false;
            } else {
                flag = true;
            }
        }
    }
    
    if (!isDaisangen(paiarray, gamestate, item))
        return true;
    return false;
}

/* V */
int isHonroutou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!item->paicategorycountlist[PAI_ZIHAI])
        return false;
    if (item->painocountlist[PAINO_2_8])
        return false;
    return true;
}

/* la */
int isRenhou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((gamestate->count == 0) && 
        (!gamestate->oya) &&
        (!gamestate->membernaki) &&
        (gamestate->tsumo == false))
        return true;
    return false;
}

/* 6ʖ */
/* F */
int isTinitsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((item->paicategorycountlist[PAI_SOUZU] >= TEHAI_LIMIT-1) ||
        (item->paicategorycountlist[PAI_PINZU] >= TEHAI_LIMIT-1) ||
        (item->paicategorycountlist[PAI_MANZU] >= TEHAI_LIMIT-1))
        return true;
    return false;
}

/*  */
/* lÍ */
int isSuuanko(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int count;

    count = item->mentsu_count[KOUTSU]/3;
    if (count == 4)
        return true;
    return false;
}

/* lÍ/PR */
int isSuuankoTanki(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (!isSuuanko(paiarray, gamestate, item))
        return false;
    if (item->mati != MATI_TANKI)
        return false;
    return true;
}

/* lȎq */
int isSuukantsu(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int count;
    
    count = item->mentsu_count[KANTSU]/4;
    if (count == 4)
        return true;
    return false;
}

/* O */
int isDaisangen(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((item->painocountlist[PAI_HAKU] >= 3) &&
        (item->painocountlist[PAI_HATSU] >= 3) &&
        (item->painocountlist[PAI_TYUN] >= 3))
        return true;
    return false;
}

/* mo */
int isKokushi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i, pos, flag;
    int counttable[TEHAI_LIMIT];

    if ((!item->paicategorycountlist[PAI_SOUZU]) ||
        (!item->paicategorycountlist[PAI_PINZU]) ||
        (!item->paicategorycountlist[PAI_MANZU]) ||
        (!item->paicategorycountlist[PAI_ZIHAI]))
        return false;
    if ((item->mentsu_count[KOUTSU]) ||
        (item->mentsu_count[SYUNTSU_START]))
        return false;
    if (item->painocountlist[PAINO_2_8])
        return false;

    for (i = 0; i < TEHAI_LIMIT; i++)
        counttable[i] = 0;
    for (i = 0; i < TEHAI_LIMIT; i++) {
        if (paiarray[i].category != PAI_ZIHAI) {
            pos = PAINO_1_9 + (paiarray[i].category * 2);
            if (paiarray[i].no == 1) {
                counttable[pos]++;
            } else if (paiarray[i].no == 9) {
                counttable[pos + 1]++;
            } else {
                return false;
            }
        } else {
            counttable[paiarray[i].no]++;
        }
    }
    
    flag = false;
    for (i = 0; i < 13; i++) {
        if ((counttable[i] == 0) || (counttable[i] >= 3))
            return false;
        if (counttable[i] >= 2) {
            if (flag) {
                return false;
            } else {
                flag = true;
            }
        }
    }
    
    return true;
}

/* Va */
int isTenhou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((gamestate->count == 0) && 
        (gamestate->oya) &&
        (gamestate->tsumo == true) &&
        !isSiisanPuutao(paiarray, gamestate, item))
        return true;
    return false;
}

/* na */
int isTiihou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((gamestate->count == 0) && 
        (!gamestate->oya) &&
        (!gamestate->membernaki) &&
        (gamestate->tsumo == true) &&
        !isSiisanPuutao(paiarray, gamestate, item))
        return true;
    return false;
}

/* la/la */
int isDaisushi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((item->painocountlist[PAI_TON] >= 3) &&
        (item->painocountlist[PAI_NAN] >= 3) &&
        (item->painocountlist[PAI_SYA] >= 3) &&
        (item->painocountlist[PAI_PEI] >= 3))
        return true;
    return false;
}

int isSyousushi(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i, atamapos;
    
    atamapos = -1;
    for (i = PAI_TON; i <= PAI_PEI; i++) {
        if (item->painocountlist[i] == 2)
            atamapos = i;
    }
    if (atamapos == -1)
        return isDaisushi(paiarray, gamestate, item);
    for (i = PAI_TON; i <= PAI_PEI; i++) {
        if (i == atamapos)
            continue;
        if (item->painocountlist[i] < 3)
            return false;
    }
    return true;
}

/* F */
int isTsuuiisou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (item->paicategorycountlist[PAI_ZIHAI] >= TEHAI_LIMIT-1)
        return true;
    return false;
}

/* V */
int isTinroutou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if (item->painocountlist[PAINO_1_9] >= TEHAI_LIMIT-1)
        return true;
    return false;
}

/* ΈF */
int isRiuiisou(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i;

    for (i = 0; i < TEHAI_LIMIT; i++) {
        if (paiarray[i].category == PAI_SOUZU) {
            if ((paiarray[i].no == 2) ||
                (paiarray[i].no == 3) ||
                (paiarray[i].no == 4) ||
                (paiarray[i].no == 6) ||
                (paiarray[i].no == 8))
                continue;
        } else if (paiarray[i].category == PAI_ZIHAI) {
            if (paiarray[i].no == PAI_HATSU)
                continue;
        }
        return false;
    }
    return true;
}

/* A */
int isTyuren(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int counttbl[10];
    int i;

    if (item->paicategorycountlist[PAI_MANZU] < TEHAI_LIMIT-1)
        return false;
    
    for (i = 0; i < 10; i++)
        counttbl[i] = 0;
    for (i = 0; i < TEHAI_LIMIT; i++)
        counttbl[paiarray[i].no]++;

    if ((counttbl[1] < 3) ||
        (counttbl[9] < 3))
        return false;
    for (i = 1; i < 10; i++) {
        if (counttbl[i] < 1)
            return false;
    }
    return true;
}

/* \Os */
int isSiisanPuutao(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    if ((gamestate->count == 0) && 
        (gamestate->tsumo) &&
        (item->mentsu_count[UKIHAI] == 12))
        return true;
    return false;
}

/* Ug𓾂 */
void yakucheck(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    t_yakufunc funclist[] = {
        isTsumo,
        isRiichi,
        isIppatsu,
        isPinfu,
        isTanyao,
        isIipeikou,
        isTon,
        isNan,
        isSya,
        isPeki,
        isHaku,
        isHatsu,
        isCyun,
        isHaitei,
        isRinsyan,
        isCyankan,
        isDora,
        isDaburii,
        isDabuTon,
        isDabuNan,
        isTiitoitsu,
        isTyanta,
        Ittsu,
        isSansyoku,
        isSanren,
        isToitoi,
        isSananko,
        isSankantsu,
        isRyanpeikou,
        isHonitsu,
        isJunchan,
        isSyousangen,
        isHonroutou,
        isRenhou,
        isTinitsu,
        isSuuanko,
        isSuuankoTanki,
        isSuukantsu,
        isDaisangen,
        isKokushi,
        isTenhou,
        isTiihou,
        isDaisushi,
        isSyousushi,
        isTsuuiisou,
        isTinroutou,
        isRiuiisou,
        isTyuren,
        isSiisanPuutao,
        NULL,
    };
    int i, j;
    
    for (i = 0; funclist[i] != NULL; i++) {
        if ((item->mentsu_count[UKIHAI] != 0) &&
            (i != YAKU_KOKUSHI) &&
            (i != YAKU_SIISANPUUTAO))
            continue;

        item->yaku[i] = funclist[i](paiarray, gamestate, item);
    }

    /* 𖞂Ȃ炻ȑO̖ƃĥ͎ĂĂ܂ */
    for (i = YAKU_SUANKO; i <= YAKU_SIISANPUUTAO; i++) {
        if (item->yaku[i]) {
            for (j = 0; j < YAKU_SUANKO; j++)
                item->yaku[j] = false;
            item->dora = 0;
            break;
        }
    }
}


/* -------------------------------------------------------- */
/* _vZ镔 */

/* Ug瓾_𓾂 */
void scorecheck(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    int i, fu, han, totalhan, yakuscore, yakumanscore, manganlimit;
    t_pai *pai;
    int mangantable[] = {
        MANGAN, HANEMAN, HANEMAN, BAIMAN,
        BAIMAN, BAIMAN, SANBAIMAN, SANBAIMAN, 
        YAKUMAN,
    };
    
    /* ʂo */
    totalhan = 0;
    for (i = 0; i < YAKU_LIMIT; i++) {
        if (item->yaku[i]) {
            han = yakutable[i].han;
            if (gamestate->naki) {
                if ((i == YAKU_TYANTA) ||
                    (i == YAKU_IITSU) ||
                    (i == YAKU_SANSYOKU) ||
                    (i == YAKU_HONITSU) ||
                    (i == YAKU_JUNCHAN)) {
                    han--;
                }
            }
            totalhan += han;
        }
    }
    if (totalhan == 0) {
        item->score = 0;
        return;
    }
    if (item->dora)
        totalhan += item->dora;
    item->han = totalhan;
    
    /* o */
    if (totalhan < 5) {
        /*  */
        if (item->yaku[YAKU_TIITOITSU]) {
            fu = 25;
        } else {
            fu = 20;
    
            /* [ɂ */
            if ((!gamestate->tsumo) && (!gamestate->naki))
                fu += 10;

            for (i = 0; i < TEHAI_LIMIT; i++) {
                /* ɂ */
                pai = paiarray + i;
                if (item->mentsu_tehai[i] == ATAMA) {
                    if (pai->category == PAI_ZIHAI) {
                        if (gamestate->zikaze == pai->no)
                            fu += 2;
                        if (gamestate->bakaze == pai->no)
                            fu += 2;
                        if ((pai->no == PAI_HAKU) ||
                            (pai->no == PAI_HATSU) ||
                            (pai->no == PAI_TYUN))
                            fu += 2;
                    }
                    i++;
                    continue;
                }
    
                /* q/Ȏqɂ */
                if (item->mentsu_tehai[i] == KOUTSU) {
                    if ((pai->category == PAI_ZIHAI) ||
                        (pai->no == 9) ||
                        (pai->no == 1)) {
                        fu += 8;
                    } else {
                        fu += 4;
                    }
                    i+=2;
                    continue;
                }
                if (item->mentsu_tehai[i] == KANTSU) {
                    if ((pai->category == PAI_ZIHAI) ||
                        (pai->no == 9) ||
                        (pai->no == 1)) {
                        fu += 32;
                    } else {
                        fu += 16;
                    }
                    i+=3;
                    continue;
                }
            }
            /* q/Ȃ͖Ή */


            /* ҂ɂ */
            if ((item->mati == MATI_KANCHAN) ||
                (item->mati == MATI_PENCHAN) ||
                (item->mati == MATI_TANKI))
                fu += 2;

            /* cオɂ /
            if ((gamestate->tsumo) && (!item->yaku[YAKU_PINFU]))
                fu += 2;

            /* 1̈ʂ؂グ */
            if (fu % 10)
                fu = ((fu / 10) + 1) * 10;
        }
        item->fu = fu;
    } else {
        item->fu = 0;
    }

    /* _o */
    if (totalhan < 5) {
        han = totalhan;
        han--;
        if (item->yaku[YAKU_TIITOITSU]) {
            fu = 50;
            han--;
        }
        fu -= 20;
        fu /= 10;
        if (gamestate->tsumo) {
            if (gamestate->oya) {
                item->oyascore = 0;
                item->koscore = score_oya_tsumo[han][fu];
                item->score = item->koscore * 3;
            } else {
                item->oyascore = score_ko_tsumo_oya[han][fu];
                item->koscore = score_ko_tsumo_ko[han][fu];
                item->score = item->oyascore + (item->koscore * 2);
            }
        } else {
            if (gamestate->oya) {
                item->score = score_oya_ron[han][fu];
                item->oyascore = item->score;
                item->koscore = item->score;
            } else {
                item->score = score_ko_ron[han][fu];
                item->oyascore = item->score;
                item->koscore = item->score;
            }
        }
    } else {
        han = totalhan;
        if (han >= 13)
            han = 13;
        han -= 5;
        if (gamestate->tsumo) {
            if (gamestate->oya) {
                item->oyascore = 0;
                item->koscore = score_mangan_oya_tsumo[han];
                item->score = item->koscore * 3;
            } else {
                item->oyascore = score_mangan_ko_tsumo_oya[han];
                item->koscore = score_mangan_ko_tsumo_ko[totalhan];
                item->score = item->oyascore + (item->koscore * 2);
            }
        } else {
            if (gamestate->oya) {
                item->score = score_mangan_oya_ron[han];
                item->oyascore = item->score;
                item->koscore = item->score;
            } else {
                item->score = score_mangan_ko_ron[han];
                item->oyascore = item->score;
                item->koscore = item->score;
            }
        }
    }

    /* шȏȂ炻ƑΉlitem->manganɓ */
    item->mangan = 0;
    if (totalhan < 5) {
        if (gamestate->oya)
            manganlimit = 12000;
        else
            manganlimit = 8000;
        if (item->score >= manganlimit)
            item->mangan = MANGAN;
    } else if (totalhan >= 5) {
        item->mangan = mangantable[han];
        yakumanscore = 0;
        for (i = YAKU_SUANKO; i <= YAKU_SIISANPUUTAO; i++) {
            if (item->yaku[i])
                yakumanscore++;
        }
        if (yakumanscore == 2)
            item->mangan = DOUBLEYAKUMAN;
        else if (yakumanscore >= 3)
            item->mangan = TRIPURUYAKUMAN;
        if (yakumanscore) {
            item->score *= yakumanscore;
            item->oyascore *= yakumanscore;
            item->koscore *= yakumanscore;
        }
    }
}


/* -------------------------------------------------------- */
/* XRA̕\ */
void printscore(t_pai *paiarray, t_gamestate *gamestate, t_resultitem *item)
{
    char *nostr[] = {"  ","","","O","l","","Z","","","",};
    char *zihaistr[] = {"","","","k","","","",};
    char *categorystr[] = {"", "", "",};
    char *manganstr[] = {"", "", "nl","{","O{","","_u","gv",};
    char *mentsustr[] = {"","","","","","","","",};
    int i, han;

    printf("\n-----------------------------------------\n");
    for (i = 0; i < TEHAI_LIMIT; i++) {
        if (paiarray[i].category != PAI_ZIHAI)
            printf("%s ", nostr[paiarray[i].no]);
        else
            printf("   ");
    }
    printf("\n");
    for (i = 0; i < TEHAI_LIMIT; i++) {
        if (paiarray[i].category != PAI_ZIHAI)
            printf("%s ", categorystr[paiarray[i].category]);
        else
            printf("%s ", zihaistr[paiarray[i].no]);
    }
    printf("\n\n");

    if ((item == NULL) ||
        (item->score == 0)) {
        printf("͊Ă܂\n");
        return;
    }

    for (i = 0; i < TEHAI_LIMIT; i++) {
        printf("%s ", mentsustr[item->mentsu_tehai[i]]);
    }
    printf("\n\n");

    for (i = 0; i < YAKU_LIMIT; i++) {
        if (item->yaku[i]) {
            han = yakutable[i].han;
            if (gamestate->naki) {
                if ((i == YAKU_TYANTA) ||
                    (i == YAKU_IITSU) ||
                    (i == YAKU_SANSYOKU) ||
                    (i == YAKU_HONITSU) ||
                    (i == YAKU_JUNCHAN)) {
                    han--;
                }
            }
            printf("%15s  %d\n", yakutable[i].name, han);
        }
    }
    if (item->dora)
        printf("%15s  %d\n", yakutable[YAKU_DORA].name, item->dora);
    printf("%15sv%d    %s\n", "", item->han, manganstr[item->mangan]);
    if (item->han < 5)
        printf("%d\n", item->fu);
    if (gamestate->tsumo) {
        if (gamestate->oya) {
            printf("%d_~3l  v%d_\n", item->koscore, item->score);
        } else {
            printf("e%d_  q%d_~2  v%d_\n", item->oyascore, item->koscore, 
                item->score);
        }
    } else {
        printf("%d_\n", item->score);
    }
}


/* -------------------------------------------------------- */
void scoresearch(t_pai *paiarray, t_gamestate *gamestate)
{
    int i, count, toppos;

    /* ̌`𓾂 */
    count = search_agari(paiarray, gamestate);
    if (count == -1) {
        printscore(paiarray, gamestate, NULL);
        return;
    }
    
    for (i = 0; i < count; i++) {
        /* 𓾂 */
        yakucheck(paiarray, gamestate, &resultlist[i]);

        /* _vZ */
        scorecheck(paiarray, gamestate, &resultlist[i]);
    }


    /* Ƃ̗p */
    toppos = 0;
    for (i = 0; i < count; i++) {
        if (resultlist[toppos].score < resultlist[i].score)
            toppos = i;
    }
    printscore(paiarray, gamestate, &resultlist[toppos]);
}


/* -------------------------------------------------------- */
int main(void)
{
    scoresearch(q1array, &q1state);
    scoresearch(q2array, &q2state);
    scoresearch(q3array, &q3state);

    return 0;
}
